> For the complete documentation index, see [llms.txt](https://support.referralhero.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://support.referralhero.com/integrate/rest-api/webhooks.md).

# Webhooks

Interacting with a third-party API like ReferralHero's can introduce two problems:

* Services not directly responsible for making an API request may still need to know the response of that request
* Some events, like deleting a subscriber, are not the result of a direct API request

Webhooks solve these problems by letting you register a URL that we will notify anytime an event happens in your campaign. When the event occurs—for example, when a user successfully subscribes to your list, ReferralHero will send a webhook notification to your registered webhooks.&#x20;

Understand that you only need to use webhooks for behind-the-scenes events. \
The results of most ReferralHero requests—including new subscriptions—are reported synchronously to your code, and don't require webhooks for verification.&#x20;

### Important Considerations

Due to the nature of network requests, your application should assume webhook requests could arrive out of order or could even fail to arrive; webhooks should be used only as notifications and not as a primary ReferralHero data source (make sure your application could still work when webhook is not available).


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://support.referralhero.com/integrate/rest-api/webhooks.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
